local FRACUNIT = FRACUNIT
local TICRATE = TICRATE

-- Got this neat little idea from Tyron's Fast Respawn

rawset(_G, "hq_superflash" , CV_RegisterVar({
	name = "hq_superflash",
	defaultvalue = "On",
	flags = 0,
	PossibleValue = CV_OnOff
}))

addHook("MapLoad", function()
	for p in players.iterate
		p.lastsupercheck = 0
	end
end)
addHook("ThinkFrame", function()
	if not hq_superform.value then return end

	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		p.hqsuperflash = $ or 0
		p.hqsuperflash = max($-1, 0)
		p.lastsupercheck = $ or 0
		
		if p.hqsuper ~= p.lastsupercheck
		and p.hqsuper ~= nil
		and leveltime >= 236 then
			if hq_superflash.value then
				p.hqsuperflash = 10
			end

			if p.hqsuper then
				S_StartSound(nil, sfx_s3k9f, p)
			else
				S_StartSound(nil, sfx_lvpass, p)
			end
		end
		
		p.lastsupercheck = p.hqsuper
	end
end)

hud.add(function(v, p, c)
	if not p.hqsuperflash then return end
	v.fadeScreen(SKINCOLOR_WHITE, min(10, max(p.hqsuperflash, 0)))
end)