-------------------------------------------------------------|
---------------HUGE QUEST by RetroStation--------------------|
----------------------and DarkyBenji-------------------------|
-------------------------------------------------------------|
freeslot(
	"sfx_hq",
	"sfx_hqa"
)
sfxinfo[sfx_hq] = {
	flags = SF_X4AWAYSOUND
}
sfxinfo[sfx_hqa]= {
	flags = SF_X4AWAYSOUND
}

rawset(_G, "HugeQuest", "Onihime") -- Heyo!

---------|
--CVars--|
---------|

rawset(_G, "hq_debug" , CV_RegisterVar({
	name = "hq_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_huge" , CV_RegisterVar({
	name = "hq_huge",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if not var.value then
			if (hq_superform.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_superform off")
				end
			end
		end
	end
}))

rawset(_G, "hq_offroad" , CV_RegisterVar({
	name = "hq_offroad",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_jumpstore" , CV_RegisterVar({
	name = "hq_jumpstore",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_sparkle" , CV_RegisterVar({
	name = "hq_sparkle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if not var.value then
			if (hq_superform.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_superform off")
				end
			end
		end
	end
}))

rawset(_G, "hq_superform" , CV_RegisterVar({
	name = "hq_superform",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			if not (hq_huge.value and hq_sparkle.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_superform off")
				end
			end
		end
	end
}))

rawset(_G, "hq_allsuper" , CV_RegisterVar({
	name = "hq_allsuper",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			if not (hq_huge.value and hq_sparkle.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_allsuper off")
				end
			end
		end
	end
}))

rawset(_G, "hq_supercolor" , CV_RegisterVar({
	name = "hq_supercolor",
	defaultvalue = "Dynamic",
	flags = 0,
	PossibleValue = {Dynamic = -1,
					Gold = 0,
					Orange = 1,
					Red = 2,
					Pink = 3,
					Blue = 4,
					Aqua = 5,
					Green = 6,
					White = 7,
					Copper = 8,
					Hyper = 9}
}))

rawset(_G, "hq_dynamictimer" , CV_RegisterVar({
	name = "hq_dynamictimer",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_altsquish" , CV_RegisterVar({
	name = "hq_altsquish",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

----------------|
--FUCKING PAIN--|
----------------|


local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
--local ANGLE_22h = ANGLE_22h
--local FRACBITS = FRACBITS
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_driftcharge = k_driftcharge
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_boostpower = k_boostpower
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_offroad = k_offroad
local k_itemroulette = k_itemroulette
local k_roulettetype = k_roulettetype
local STARTTIME = 6*TICRATE + (3*TICRATE/4)
local pks

rawset(_G, "growplus", {speedmod = FRACUNIT/10, timer = (12*TICRATE)})

--Init------|
----And-----|
------Sync--|

local function hq_init(p)
	p.huge = 0 -- New Grow timer
	p.hqspeen = false
	p.hqboom = false
	p.hqspb = false
	p.hqtackle = false
	p.hqsuper = 0 -- Super flag
	p.hqgstacks = 0 -- How many times you've stacked Grow
	p.hqsupershift = 1 -- Animated Super glow
	p.hqleadbuffer = 0 -- Buffer for position shuffles and jankpoints
	--prev tics
	p.HQLFitem = 0
	p.HQLFamount = 0
end

------------|
------------|
------------|

local function GrowplusEndCheck(p)
	if p.huge == 1 
	or p.hqsuper == 1
	or p.playerstate ~= PST_LIVE 
	or p.pflags & PF_TIMEOVER
	or (p.kartstuff[k_invincibilitytimer] == 0 and p.kartstuff[k_growshrinktimer] < 0) then
		return true
	else 
		return false 
	end
end

local function buildTimeString(x)
	if x == nil or x == 99999999 then return "N/A" end
	return (""..string.format("%02d", G_TicsToMinutes(x)).."'"..string.format("%02d", G_TicsToSeconds(x)).."\34"..string.format("%02d", G_TicsToCentiseconds(x)))
end

--- Music Transition block for new Invincibility and Grow ---
addHook("MusicChange", function(oldmusic, newmusic, flags, looping)
	--print("oldmusic:"..oldmusic.."  newmusic:"..newmusic)
	
	for dp in displayplayers.iterate
		//print("Huge:"..dp.huge.." Sparkle:"..dp.kartstuff[k_invincibilitytimer])
		if GrowplusEndCheck(dp) or dp.exiting or leveltime < STARTTIME then continue end
		if (dp.huge and dp.huge > 1) and dp.kartstuff[k_invincibilitytimer] <= 1 //What do you mean the music stop at 1?!
			if not (newmusic == "kgrow")
				return "kgrow", flags, true
			end
		end
		
		
		if dp.kartstuff[k_invincibilitytimer] > 1
		and dp.huge > 1
		and hq_superform.value
		and not hq_allsuper.value
		and not dp.mo.hqtrans then
			if ((newmusic == "kgrow") or (newmusic == "kinvnc"))
			or ((oldmusic == "kgrow") or (oldmusic == "kinvnc"))
				return "hqsupr", flags, true
			end
		end
		

		if dp.hqsuper
			if oldmusic == "hqsupr"
			and (newmusic == "kgrow" or newmusic == "kinvnc")
				return true
			end
		end
		
		if dp.mo.hqtrans then -- For Custom character themes
			if newmusic == "kgrow" 
			or newmusic == "kinvnc"
				return true
			end
		end
	end
end)

local function hq_ingame()
	local count = 0
	for p in players.iterate
		if not (p.mo and p.mo.valid) or p.spectator then continue end 
		count = $ + 1
	end
	return count
end


-- Thank you Ashnal for an optimized distance check
local function HQ_DynamicTimer(p)
	-- Timer drains progressively faster in the lead
	return FixedRound((p.hqleadbuffer*FRACUNIT)/35)/FRACUNIT
end

local function HQ_LeadBuffer(p)
	if not (hq_dynamictimer.value) then return end
	--print("Buffer: "..p.hqleadbuffer)

	if p.kartstuff[k_position] == 1
	and	hq_ingame() > 1 then
		p.hqleadbuffer = min($+2, 12*TICRATE)
	else
		p.hqleadbuffer = max($-4, 0)
	end
	--print("Buffer: "..p.hqleadbuffer)
	--print("Decay: "..HQ_DynamicTimer(p))
end

local function HQ_SuperColorAssign(mo)
	if not hq_superform.value then return end
	if not (mo and mo.valid and mo.player) then return end
	if not mo.hqassignedcolor -- Only need this for one frame
		-- Aiai: Insert Blutz Waves here
		if (mo.skin == "aiai"
		or mo.skin == "eggman"
		or mo.skin == "ray") then
			mo.hqsupernumber = 0
			mo.hqassignedcolor = true
		-- Kuze: Heat Mode
		elseif (mo.skin == "tails"
		or mo.skin == "kuze"
		or mo.skin == "arle"
		or mo.skin == "cream"
		or mo.skin == "metalsonic") then
			mo.hqsupernumber = 1
			mo.hqassignedcolor = true
		-- Kiryu: Climax Heat Mode
		elseif (mo.skin == "knuckles" 
		or mo.skin == "kiryu"
		or mo.skin == "mighty"
		or mo.skin == "gamma"
		or mo.skin == "omega"
		or mo.skin == "darkchao"
		or mo.skin == "motobug") then
			mo.hqsupernumber = 2
			mo.hqassignedcolor = true
		-- Majima: Legend Heat Mode
		elseif (mo.skin == "blaze"
		or mo.skin == "majima"
		or mo.skin == "ulala"
		or mo.skin == "amy"
		or mo.skin == "sakura"
		or mo.skin == "espio"
		or mo.skin == "nights"
		or mo.skin == "rouge") then
			mo.hqsupernumber = 3
			mo.hqassignedcolor = true
		elseif (mo.skin == "vyse"
		or mo.skin == "chaos") then
			mo.hqsupernumber = 4
			mo.hqassignedcolor = true
		-- Copen/GV: Anthem
		elseif (mo.skin == "gunvolt" 
		or mo.skin == "copen"
		or mo.skin == "chao"
		or mo.skin == "miku") then
			mo.hqsupernumber = 5
			mo.hqassignedcolor = true
		elseif (mo.skin == "beat"
		or mo.skin == "wonderboy"
		or mo.skin == "doom"
		or mo.skin == "vector") then
			mo.hqsupernumber = 6
			mo.hqassignedcolor = true
		elseif (mo.skin == "herochao"
		or mo.skin == "aigis"
		or mo.skin == "silver") then
			mo.hqsupernumber = 7
			mo.hqassignedcolor = true
		elseif (mo.skin == "shadow") then
			mo.hqsupernumber = 8
			mo.hqassignedcolor = true
		-- Hyper Sonic
		elseif (mo.skin == "sonic"
		or mo.skin == "flicky") then
			mo.hqsupernumber = 9
			mo.hqassignedcolor = true
		else
			return 
		end
		
	end
end
addHook("MobjThinker", HQ_SuperColorAssign, MT_PLAYER)

--- Grow Reconstruction: Base code by Benji, balance adjustments by RetroStation--- 
local function K_HugeQuest(p)
	if not (hq_huge.value) then return end
	
	pks = p.kartstuff
	if pks[k_growshrinktimer] > 0
		if JUICEBOX
			p.JBlastgst = 0
		end
		if (battleplus and G_BattleGametype())
			p.huge = growplus.timer+1
			--Grow+ doesn't stack in BattlePlus to prevent cheese in modes 
			--like Emerald Thief
		else
			if chaosdrives
			and (CV_FindVar("cd_mode").value ~= 3
			or CV_FindVar("cd_mode").value ~= 0)
			and P_RandomChance(((p.cd_run+p.cd_swim+p.cd_fly+p.cd_power)*FRACUNIT)/(chaosdrives.max*10)) -- Max 40% chance at full Drives
			and hq_superform.value then -- More drives ups the chances of spontaneous Super Form
				--Super Form!
				p.mo.sparkle = (growplus.timer+1)
				pks[k_invincibilitytimer] = p.huge
				p.huge = 1
				p.hqsuper = 1
				S_ChangeMusic("HQSUPR", true, p)
			else
				if p.huge > 0
				and p.hqgstacks >= 2
					p.huge = (($+(growplus.timer+1))*3)/4		
				else
					p.huge = $+(growplus.timer+1)
				end
			
				if hq_superform.value -- Activate Super Form
				and p.mo.sparkle
					p.huge = min(($+p.mo.sparkle)/2, 10*TICRATE)
					p.mo.sparkle = p.huge
					p.huge = 1
					p.hqsuper = 1
					S_ChangeMusic("hqsupr", true, p)
				end
			end
		end

		p.hqgstacks = $+1

		pks[k_growshrinktimer] = 0
		//print("timer:"..p.huge)
		//print("HUGE QUEST")
	end

	if p.huge >= 1 
	or p.hqsuper then
		if p.huge
		and not p.hqsuper then
			if hq_dynamictimer.value then
				p.huge = min(max(($-(HQ_DynamicTimer(p)+1)), 1), 36*TICRATE)
				-- Decays faster in better positions
			else
				p.huge = max($ - 1, 1)
			end
		end
		
		if hq_offroad.value then
			pks[k_speedboost] = max($, growplus.speedmod)
		else
			pks[k_speedboost] = max($, (growplus.speedmod)*2)
		end
		
		pks[k_accelboost] = max($, ((3*FRACUNIT)/2))

		if hq_offroad.value then
			pks[k_offroad] = 0
			pks[k_boostpower] = max($, FRACUNIT)

			if S_SoundPlaying(p.mo, sfx_cdfm70) --delete offroad sound
				S_StopSoundByID(p.mo, sfx_cdfm70)
			end
		end
				
		if pks[k_hyudorotimer]
			pks[k_hyudorotimer] = 0
			p.powers[pw_flashing] = 0 
			if kmp != nil 
			and kmp_extendflashtics.value then 
				p.mo.K_fakeflashing = 0
			end //lol KartMP
		end

		if pks[k_roulettetype] == 2 then
			pks[k_roulettetype] = 1
		end

		if pks[k_itemblink] == TICRATE-1
			if pks[k_itemtype] == 1 then -- Sneakers
				if not p.hqsuper then
					pks[k_itemtype] = 6
				else
					pks[k_itemamount] = min($, 2) -- Super doesn't need 3x lmao
				end
			end
			
			if pks[k_itemtype] == 5 then -- Eggman
				pks[k_itemtype] = 8
			end
			
			if pks[k_itemtype] == 2 then -- Rocket Sneaks
				if p.hqsuper
					pks[k_itemtype] = 1
					pks[k_itemamount] = 2 -- Guaranteed 2x Sneakers
				else
					pks[k_itemtype] = 3
				end
			end
			
			if (pks[k_itemtype] == 3 or pks[k_itemtype] == 11)
			and p.hqsuper then
				S_StartSound(p.mo, sfx_cgot, p)
				p.mo.sparkle = $ + 6*TICRATE -- net ~3 seconds because of roulette timer
				K_StripItems(p)
			end

			if pks[k_itemtype] == 14 then -- Hyuu
				if P_RandomChance(FRACUNIT/10)
					pks[k_itemtype] = 16
				else
					if P_RandomChance(FRACUNIT/2)
						pks[k_itemtype] = 6
						pks[k_itemamount] = 4
					else
						pks[k_itemtype] = 4
						pks[k_itemamount] = 10				
					end
				end
			end
		end
	end
		
	if p.huge > 0 and GrowplusEndCheck(p)
		if not p.hqsuper then
			p.mo.colorized = false
			p.mo.color = p.skincolor
			P_RestoreMusic(p)
		end
		p.mo.scalespeed = mapobjectscale/TICRATE
		p.mo.destscale = mapobjectscale
		pks[k_growshrinktimer] = 0
		p.huge = 0
		p.hqgstacks = 0
	end
end

--Offroad dust? Fuck that.
local function HQ_NoDust(mo)
	if not (hq_offroad.value) then return end
	if not (mo and mo.valid) return end
	if not (mo.target and mo.target.valid) return end
	if mo.target.player.huge
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
end
addHook("MobjThinker", HQ_NoDust, MT_WIPEOUTTRAIL)

--Friction? Fuck that.
local function HQ_NoGlue(mo)
	if not (hq_huge.value) return end
	if not (mo and mo.valid and mo.player) return end
	if leveltime < TICRATE return end
	//if leveltime >= 236
		//print(mo.friction)
	//end
	if mo.player.huge
		mo.friction = max($, 62914)
	end
end
addHook("MobjThinker", HQ_NoGlue, MT_PLAYER)


--Pipes? Thwomps? FUCK 'EM.
local ded = {MT_SMK_PIPE, MT_SMK_THWOMP}
for _,i in ipairs(ded) do
	addHook("MobjCollide", function(mo, mo2)
		if not (hq_huge.value) return end
		if not (mo and mo.valid) return end
		if not mo2.player return end
		if mo2.player
			if (mo2.player.huge > 0 or mo2.player.mo.sparkle > 0) and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) -- Height check
				P_KillMobj(mo, mo2, mo2)
			end
		end
	end, i)
end

--Eggbomb Fix--
local function noeggroll (mo, mo2)
	if mo2.player
	and (mo2.player.huge > 0
	or mo2.player.mo.sparkle > 0)
		if mo2.player.kartstuff[k_itemtype]
			return true
		else
			return false
		end
	end
	return
end
addHook("TouchSpecial", noeggroll, MT_EGGMANITEM)

-- Oops! All Super --
local function hq_instasuper(mo, mo2)
	if not (mo2 and mo2.player) then return end
	
	local p = mo2.player
	if hq_allsuper.value
	and hq_superform.value then
		if not p.hqsuper then
			p.mo.sparkle = 99*TICRATE
			p.hqsuper = 1
			S_ChangeMusic("hqsupr", true, p)
			K_PlayPowerGloatSound(p.mo)
			//print(HQ_SuperCheck(p))
		else
			return true
		end
	end
	return
end
addHook("TouchSpecial", hq_instasuper, MT_RANDOMITEM)

local attackitems = {MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_SHIELD, MT_JAWZ_DUD, MT_BALLHOG, MT_BANANA}

--- Don't Stop Me Now --- 
local function hugeinv(p, inf, source)
	if (p.huge > 0 or p.mo.sparkle)
		if inf and inf.valid
			if ((inf.type == MT_ORBINAUT)
			or (inf.type == MT_ORBINAUT_SHIELD)
			or (inf.type == MT_JAWZ)
			or (inf.type == MT_JAWZ_SHIELD)
			or (inf.type == MT_JAWZ_DUD)
			or (inf.type == MT_BALLHOG)
			or (inf.type == MT_BANANA)) then
				if not p.powers[pw_flashing]
				and hq_dynamictimer.value then
					if p.huge
						p.huge = max($-(TICRATE), 1)
					end
				
					if p.mo.sparkle
						p.mo.sparkle = max($-(TICRATE), 1)
					end
					S_StartSound(p.mo, sfx_s1ac)
					S_StartSound(p.mo, sfx_s1ac)
					S_StartSound(p.mo, sfx_s1ac)
					p.powers[pw_flashing] = TICRATE/2
					if kmp != nil 
					and kmp_extendflashtics.value then 
						p.mo.K_fakeflashing = 0 -- NO FUCK YOU
						p.powers[pw_flashing] = TICRATE/2 -- NO EXTENDED GRACE
					end
				end
				return false
			elseif (inf.player
			and (source and source.player and source.sparkle)
			and p.huge > 0) then
				return
			else
				K_DoInstashield(p)
				return false
			end
		else -- Lol, they said. Lmao
			K_DoInstashield(p)
			return false
		end
	end
	return
end

local function hqtank(p)
	if p.huge > 0
	or p.mo.sparkle > 0
		if not p.powers[pw_flashing]
		and hq_dynamictimer.value then
			if p.huge
				p.huge = max($-((3*TICRATE)/2), 1)
			end
		
			if p.kartstuff[k_invincibilitytimer]
				p.mo.sparkle = max($-((3*TICRATE)/2), 1)
			end

			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			p.powers[pw_flashing] = TICRATE/2
			if kmp != nil 
			and kmp_extendflashtics.value then 
				p.mo.K_fakeflashing = 0 -- NO FUCK YOU
				p.powers[pw_flashing] = TICRATE/2 -- NO EXTENDED GRACE
			end
		end
		return false
	end
	return
end

---Bless Togen for these Hooks---
addHook("ShouldDamage", function(mo, inflictor, source, damage)
    if not (mo and mo.valid and mo.player) then return end
	local mop, mopks = mo.player, mo.player.kartstuff
	
    if damage < 10000 then
		if mop.huge > 0
		or mop.kartstuff[k_invincibilitytimer] > 0
			if inflictor and inflictor.valid
				if ((inflictor.type == MT_ORBINAUT) 
				or (inflictor.type == MT_ORBINAUT_SHIELD) 
				or (inflictor.type == MT_JAWZ) 
				or (inflictor.type == MT_JAWZ_DUD) 
				or (inflictor.type == MT_JAWZ_SHIELD)) then
					mo.momx = $/2
					mo.momy = $/2
				end
				if ((inflictor.type == MT_ORBINAUT)
				or (inflictor.type == MT_ORBINAUT_SHIELD)
				or (inflictor.type == MT_JAWZ)
				or (inflictor.type == MT_JAWZ_SHIELD)
				or (inflictor.type == MT_JAWZ_DUD)
				or (inflictor.type == MT_BALLHOG)
				or (inflictor.type == MT_BANANA)
				or (inflictor.player and inflictor.player.kartstuff[k_curshield] == 1)) then
					if not mop.powers[pw_flashing] 
					and hq_dynamictimer.value then
						if mop.huge
							mop.huge = max($-(TICRATE), 1)
						end
					
						if mo.sparkle
							mo.sparkle = max($-(TICRATE), 1)
						end
						S_StartSound(mo, sfx_s1ac)
						S_StartSound(mo, sfx_s1ac)
						S_StartSound(mo, sfx_s1ac)
						mop.powers[pw_flashing] = TICRATE/2
						if kmp != nil 
						and kmp_extendflashtics.value then 
							mo.K_fakeflashing = 0 -- NO FUCK YOU
							mop.powers[pw_flashing] = TICRATE/2 -- NO EXTENDED GRACE
						end
						return false
					end
				else
					return false
				end
			end
		end
	elseif damage >= 10000 -- Sink stuff
		if mop.hqsuper
			if (inflictor and inflictor.type == MT_SINK)
				if (source and source.player)
					if not (CV_FindVar("kmp_respawnpoints") and CV_FindVar("kmp_respawnpoints").value) then
						if P_IsObjectOnGround(source.player.mo) then
							local x,y,z = source.player.mo.x, source.player.mo.y, source.player.mo.z
							local ang = source.player.mo.angle
							source.player.hqrespawn = {x, y, z, ang, source.player.mo.eflags & MFE_VERTICALFLIP}
						end
					end
					S_StartSound(source.player.mo, sfx_toada)
					P_DamageMobj(source.player.mo, MT_SINK, mo, 10000) -- NO U
					if (server) then
						local name = source.player.name
						local hqsuper = mop.name
COM_BufInsertText(server, "csay "..name.."\\tried throwing a kitchen sink at \\Super "..hqsuper..".")
					end
					return false
				end
			end
		end
	end
	return
end)
addHook("ShouldExplode", hqtank)
addHook("ShouldSpin", hugeinv)
addHook("ShouldSquish", function(p, inf, s)
	if not (hq_altsquish.value) then return end

	if not (inf and inf.valid and inf.player) then
		return true
	end
	
	return
end)

---Item Size Scaling; shoutouts to Titou's Comet weather---
local bigitem = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_BALLHOG, MT_SINK}
for _,i in ipairs(bigitem) do
	addHook("MobjThinker", function(mo)
		if (not hq_huge.value) or (not mo and mo.valid) then return end
		
		if (mo.target and mo.target.valid) and (mo.target.player and mo.target.player.valid) and not mo.beeg then -- fear
			mo.beeg = 1	
			if (mo.target.player.huge)
			or mo.target.player.hqsuper then
				mo.scale = (2*mapobjectscale)
				mo.bigmclargehuge = 1
			end
		end
		
		if mo.scale == (mapobjectscale*2) then
			local addx = FixedMul(mo.momx, mapobjectscale/2)
			local addy = FixedMul(mo.momy, mapobjectscale/2)
			P_TryMove(mo, (mo.x + addx), (mo.y + addy), mo.z, false)		
			//debug
			//if mo.type == MT_ORBINAUT and not mo.glass
				//mo.health = 1
				//mo.glass = true
			//end
		end
	end, i)
end

---Extended Spinout (from Benji)---
local function K_HQBonk (p)
	if (hq_huge.value) then
		if p.kartstuff[k_spinouttimer] 
			if p.hqspeen then
				p.kartstuff[k_spinouttimer] = $*11/10 //+10%
				p.hqspeen = false
			elseif p.hqboom then
				p.kartstuff[k_spinouttimer] = $*6/5 //+20%
				p.mo.momz = $*5/4
				p.hqboom = false
			elseif p.hqtackle then
				if not p.mo.hqsupertackle then
					p.mo.momz = FixedMul($ + (16*mapobjectscale), sin(ANGLE_45))
					p.mo.hqsupertackle = true
					S_StartSound(p.mo, sfx_toada)
				end

				if not P_IsObjectOnGround(p.mo) then
					p.kartstuff[k_spinouttimer] = $+1
				end
				
				if p.kartstuff[k_spinouttimer] == 1 then
					p.hqtackle = false
					if p.mo.hqsupertackle then
						p.mo.hqsupertackle = nil
					end
				end
			end
		end
	end
end

---The Big Ones---
local function ohhhhbanana (mo)
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local banan = FixedMul(5*FRACUNIT, mo.scale)
	local boffset = FixedMul(FRACUNIT, mo.scale)
	if (mo.scale >= (2*mapobjectscale) and mo.bigmclargehuge)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		//print("OHHHH BANANA")
		local split1 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split1.potassium = true
		split1.owner = mo.owner
		//split1.momx = FRACUNIT*cos(mo.angle-ANGLE_135)
		split1.momy = FixedMul(banan, cos(mo.angle))
		split1.momz = FixedMul(banan, sin(ANGLE_45))
		split1.beeg = 1
		local split2 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split2.potassium = true
		split2.target = mo.target
		split2.momx = FixedMul(-banan, cos(mo.angle))
		//split2.momy = FRACUNIT*sin(mo.angle+ANGLE_135)
		split2.momz = FixedMul(banan, sin(ANGLE_45))
		split2.beeg = 1
		local split3 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split3.potassium = true
		split3.target = mo.target
		split3.momx = FixedMul(banan, cos(mo.angle))
		//split3.momy = FixedMul(FixedMul(banan, sin(mo.angle)), cos(ANGLE_45))
		split3.momz = FixedMul(banan, sin(ANGLE_45))
		split3.beeg = 1
	end
end
addHook("MobjDeath", ohhhhbanana, MT_BANANA)

local function PraiseBeToBanan(mo)
	if not mo and mo.potassium return end
	if mo.potassium == true
		if not P_IsObjectOnGround(mo)
			mo.flags = $ | MF_NOCLIPTHING
		else
			mo.flags = $ & ~MF_NOCLIPTHING
		end
	end
end
addHook("MobjThinker", PraiseBeToBanan, MT_BANANA)

//local function BananDebug(mo)
	//if not mo.potassium
		//mo.scale = 2*mapobjectscale
	//end
//end

//addHook("MobjThinker", BananDebug, MT_BANANA)

--local balltimer = TICRATE/5
--local split1
--local split2
--local split3
--local split4

local function pinball (mo)
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local dis = 40
	local ball = FixedMul((dis*FRACUNIT), mo.scale)
	local balldiff = FixedMul(((2*dis)*FRACUNIT), mo.scale)
	local angdiff = ANGLE_45
	local hqspawn = 0
	if (mo.scale >= (2*mapobjectscale) and mo.bigmclargehuge)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		while hqspawn < 2 -- Thank you micenice
		do
			local split = P_SpawnMobj(x+FixedMul((ball-(balldiff*hqspawn)), cos(mo.angle)), y-FixedMul((ball-(balldiff*hqspawn)), sin(mo.angle)), z, MT_ORBINAUT)
			split.movefactor = 64*mapobjectscale
			split.target = mo.target
			P_InstaThrust(split, (mo.angle+(-ANGLE_22h+(angdiff*hqspawn))), split.movefactor)
			split.bouncy = true
			split.beeg = 1
			hqspawn = $+1
		end
	end
end
addHook("MobjDeath", pinball, MT_ORBINAUT)

local function HQ_Superball(mo)
	if not (mo and mo.valid) then return end
	if not mo.bouncy then return end
	if P_IsObjectOnGround(mo) then
		mo.momz = FixedMul((30*FRACUNIT), mapobjectscale)
	end
end
addHook("MobjThinker", HQ_Superball, MT_ORBINAUT)

local balls = {MT_ORBINAUT, MT_ORBINAUT_SHIELD}
for _,i in ipairs(balls) do
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		if not (mo.target and mo.target.valid and mo.target.player) then return end
	
		if mo.target and mo.target.player then
			local pmo = mo.target
			local p = mo.target.player
			if not mo.superglow then
				if p.hqsuper	
					mo.hqsuperglow = 1
				else
					mo.hqsuperglow = -1
				end
			end
		end
		
		if mo.hqsuperglow == 1 then
			mo.hqsupershift = 1
			mo.color = HQ_animSuper[7][mo.hqsupershift]
			if leveltime%5 == 0 then
				if mo.hqsupershift == #HQ_animSuper[7]
					mo.hqsupershift = 1
				else
					mo.hqsupershift = $ + 1
				end
			end
		elseif mo.hqsuperglow == -1 
		and not mo.hqcolorset then
			mo.color = mo.target.player.skincolor
			mo.hqcolorset = true
		end
	end, i)
end
-- Ported from Togen's Chaos Drive because I forgot to write a handling modifier
local function HQ_HandlingMod(p)
	if not ((p.huge > 0 or p.kartstuff[k_growshrinktimer] > 0)
	or p.kartstuff[k_sneakertimer]
	or p.kartstuff[k_invincibilitytimer]) then
		return
	end
	
	-- Stats
	local s = p.kartspeed
	local a = 9 - s
	local w = p.kartweight
	local h = 9 - w

	--Speed
	local g_cc = 56320 + (12288 * gamespeed)
	local shiftby = 14
	local desiredspeed = FixedMul((150 + s*3)<<shiftby, g_cc)

	local onground = P_IsObjectOnGround(p.mo)
			
	-- Drifting
	local function HQ_GetKartDriftValue(countersteer, handling)
		if ((p.kartstuff[k_drift] == 0) or (not onground))
			return 0
		elseif (p.kartstuff[k_driftend] ~= 0)
			return -266*p.kartstuff[k_drift]
		else
			local driftweight = (9-handling)*14
			local basedrift = 83*p.kartstuff[k_drift] - (driftweight - 14)*p.kartstuff[k_drift]/5
			local driftangle = abs((252 - driftweight)*p.kartstuff[k_drift]/5)
			return basedrift + FixedMul(driftangle, countersteer)
		end
	end

	local turninput = p.cmd.driftturn		
	local function HQ_GetKartTurnValue(t, weight)
		local p_maxspeed = FixedMul(desiredspeed, 3*FRACUNIT)
		local adjustangle = FixedDiv((p_maxspeed>>FRACBITS) - (p.speed>>FRACBITS), (p_maxspeed>>FRACBITS) + (10-weight))
				
		if (p.kartstuff[k_drift] ~= 0 and onground)
			if (p.kartstuff[k_driftend] == 0)
				local countersteer = FixedDiv(turninput*FRACUNIT, 800*FRACUNIT)
				t = HQ_GetKartDriftValue(countersteer, h)
			else
				t = $ + HQ_GetKartDriftValue(FRACUNIT, h)
			end
		end
		t = FixedMul($, adjustangle)
			
		t = FixedMul($, FixedDiv(5*FRACUNIT, 4*FRACUNIT))
				
		return t
	end
	
	local trueturning = HQ_GetKartTurnValue(turninput, h)
	local desiredturning = HQ_GetKartTurnValue(turninput, h)
	local turningdiff = desiredturning - trueturning
			
	if(abs(p.speed) > 0)
		p.cmd.angleturn = $ + (turningdiff<<20)
	end
end


local function CheckInvincibility(p)
	if p.kartstuff[k_roulettetype] 
	or p.kartstuff[k_stolentimer] 
	or p.kartstuff[k_spinouttimer] 
	or p.kartstuff[k_wipeoutslow]
		return true
	end
	return false
end

local function K_Stardust(p)
	if not (hq_sparkle.value) then return end
	
	pks = p.kartstuff
	p.mo.sparkle = $ or 0
	p.mo.hqistacks = $ or 0
	local shiny = (10*TICRATE)
	//if leveltime > STARTTIME
	//	print("K_Stardust".." IT: "..pks[k_itemtype].." LFIT: "..p.HQLFitem.." IA: "..pks[k_itemamount].." LFIA: "..p.HQLFamount)
	//end

	if p.HQLFitem == 3
	and pks[k_itemamount] < p.HQLFamount
	and not CheckInvincibility(p) then
		//print("STAR POWER")
		if not (battleplus and G_BattleGametype()) -- No cheesing with stacked Invincibility either
			if chaosdrives
			and (CV_FindVar("cd_mode").value ~= 3
			or CV_FindVar("cd_mode").value ~= 0)
			and P_RandomChance(((p.cd_run+p.cd_swim+p.cd_fly+p.cd_power)*FRACUNIT)/(chaosdrives.max*10)) -- Max 40% chance at full Drives
			and hq_superform.value then -- More drives ups the chances of spontaneous Super Form
				--Super Form!
				p.mo.sparkle = ($ + (shiny+1))
				pks[k_invincibilitytimer] = p.mo.sparkle
				if p.huge then
					p.huge = 1
				end
				p.hqsuper = 1
			else
				if p.mo.sparkle
				and p.mo.hqistacks >= 2 then
					p.mo.sparkle = (($ + shiny + 1)*3)/4
				else
					p.mo.sparkle = $ + (shiny + 1)
				end
			
				if hq_superform.value
				and p.huge > 0 then
					--print("SHAZAM")
					p.mo.sparkle = min(($ + p.huge)/2, 10*TICRATE)
					p.huge = 1
					p.hqsuper = 1
				end
			end

			p.mo.hqistacks = $+1
		end
	end
	
	if p.mo.sparkle > 0
		if hq_dynamictimer.value then
			if p.hqsuper then
				p.mo.sparkle = min(max(($-(HQ_DynamicTimer(p)+1)), 1), 15*TICRATE)
			else
				p.mo.sparkle = min(max(($-(HQ_DynamicTimer(p)+1)), 1), 30*TICRATE)
			end
		else
			p.mo.sparkle = max($-1, 1)
		end
		pks[k_invincibilitytimer] = p.mo.sparkle
		
		if p.kartstuff[k_roulettetype] == 2 then
			p.kartstuff[k_roulettetype] = 1
		end
		//print("timer:"..p.mo.sparkle)
		if p.hqsuper then
			p.kartstuff[k_speedboost] = max($, (4*FRACUNIT)/5)
			
			if pks[k_driftboost] > 0
				p.kartstuff[k_speedboost] = max($, (22*FRACUNIT)/25)
			end

			if p.kartstuff[k_sneakertimer] > 0
				p.kartstuff[k_speedboost] = max($, FRACUNIT)
			end
		end
		
		if p.mo.sparkle == 1 then
			p.mo.sparkle = 0
		end
	end

	if not p.mo.sparkle
		p.mo.hqistacks = 0
		p.hqsuper = 0
	end
	
	
	p.HQLFitem = pks[k_itemtype]
	p.HQLFamount = pks[k_itemamount]
			
	if pks[k_spinouttimer] > 0
	or pks[k_wipeoutslow] > 0
		p.mo.sparkle = 0
		pks[k_invincibilitytimer] = 0
		p.hqistacks = 0
	end
end

--- Sonic 1 throwback ---
local function classicsonic(mo)
	if not (mo and mo.valid) return end
	if (not hq_sparkle.value) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	local p = mo.target.player
	local pmo = mo.target
	if p.hqsuper then
		if hq_supercolor.value == -1 then
			if p.hqsupershift > 5
			and p.mo.hqsupernumber ~= 9 then
				p.hqsupershift = 1
			end

			if p.mo.hqsupernumber ~= nil then
				mo.color = HQ_animSuper[p.mo.hqsupernumber][p.hqsupershift]
			else
				mo.color = HQ_animSuper[0][p.hqsupershift]
			end
		else
			if p.hqsupershift > 5
			and hq_supercolor.value ~= 9 then
				p.hqsupershift = 1
			end
			mo.color = HQ_animSuper[hq_supercolor.value][p.hqsupershift]
		end
		mo.colorized = true
	else
		--if p.kartstuff[k_invincibilitytimer] >= 3*TICRATE then
			if not (BoostFX and p.bfxflamecolor >= 103)
				mo.color = SKINCOLOR_WHITE
				mo.colorized = true
			end
		--elseif (p.kartstuff[k_invincibilitytimer] > 0
		--and p.kartstuff[k_invincibilitytimer] < 3*TICRATE) then
		--	mo.color = SKINCOLOR_RED
		--	mo.colorized = true
		--end
	end
end
addHook("MobjThinker", classicsonic, MT_SPARKLETRAIL)

local function HQ_PowerColor(p)
	pks = p.kartstuff
	
	if p.hqsuper then
		if hq_supercolor.value == -1 then
			if p.hqsupershift > 5
			and p.mo.hqsupernumber ~= 9 then
				p.hqsupershift = 1
			end

			if p.mo.hqsupernumber ~= nil
				if p.mo.hqsupernumber == 9 then
					if leveltime%3 == 0 then
						if p.hqsupershift >= #HQ_animSuper[9]
								p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				else
					if leveltime%5 == 0 then
						if p.hqsupershift >= #HQ_animSuper[p.mo.hqsupernumber]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				end
			end
			p.mo.color = HQ_animSuper[p.mo.hqsupernumber][p.hqsupershift]
		else
			if p.hqsupershift > 5
			and hq_supercolor.value ~= 9 then
				p.hqsupershift = 1
			end
			if hq_supercolor.value == 9 then -- Hyper Color Cycle
				if leveltime%5 == 0 then
					if p.hqsupershift >= #HQ_animSuper[hq_supercolor.value]
						p.hqsupershift = 1
					else
						p.hqsupershift = $ + 1
					end
				end
			else
				if leveltime%5 == 0 then
					if p.hqsupershift >= #HQ_animSuper[hq_supercolor.value]
						p.hqsupershift = 1
					else
						p.hqsupershift = $ + 1
					end
				end
			end
		p.mo.color = HQ_animSuper[hq_supercolor.value][p.hqsupershift]
		end
		--print(p.mo.color)
		p.mo.colorized = false
	else
		--if not HQ_PowerTimerEnd(p) then
			if not (BoostFX)
			or (BoostFX and p.bfxflamecolor < 103)
				if p.huge > 0 then
					if not pks[k_invincibilitytimer]
						if leveltime%10 > 4
							if hq_offroad.value then
								p.mo.color = SKINCOLOR_JAWZ
							else
								p.mo.color = SKINCOLOR_PERIWINKLE
							end
							p.mo.colorized = true
						else
							p.mo.color = p.skincolor
							p.mo.colorized = false
						end
					end
				end

				if p.mo.sparkle then
					if leveltime%10 > 4 then
						p.mo.color = SKINCOLOR_WSUPER3
					else
						p.mo.color = SKINCOLOR_PERIWINKLE
					end
					p.mo.colorized = false
				else
					return
				end
			end
		--end
	end
end

---We don't waste MT in this house--
local function K_JumpStore(p)
	if not (hq_jumpstore.value) then return end
	
	pks = p.kartstuff
	
	if pks[k_driftboost] > 0
		//print("DriftBoost:"..pks[k_driftboost])
		if (not P_IsObjectOnGround(p.mo))
		or pks[k_sneakertimer]
        or (pks[k_sneakertimer] and (p.tricksneakerbuffer or p.trickboost))
		and p.playerstate == PST_LIVE
			pks[k_driftboost] = $+1
		end
	end
	
	if p.hqsuper
	and hq_dynamictimer.value then
		if ((not P_IsObjectOnGround(p.mo))
		or (pks[k_sneakertimer] and not p.trickboost)
		or p.mo.recharge)
		and not p.mo.hqpadboost
		and p.playerstate == PST_LIVE
		and not (p.kartstuff[k_itemroulette]) -- Yeah no, mash your shit if you want better gains from Power pulls
			p.mo.sparkle = $ + 1 -- We don't waste Super either
		end
	end
end


local function K_HQNyoom(mo)
	if not (hq_jumpstore.value) or not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	
	if mo.target and mo.target.player then
        if mo.target.player.kartstuff[k_driftboost] > 0
        and ((not acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0)
        or (acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0 and mo.target.player.tricksneakerbuffer > 0))
			mo.color = SKINCOLOR_HANDHELD
			mo.colorized = true
		else
			if not mo.target.player.bfxlinecolor
				mo.colorized = false
			end
		end
	end
end
addHook("MobjThinker", K_HQNyoom, MT_FASTLINE)

--LOOK ALIVE (from Benji)--
local sfxnum, localplayer = 0, nil
local function STOPTHIS(p, this)
	if (sfxnum != this and S_SoundPlaying(p.mo, this)) then
		S_StopSoundByID(p.mo, this)
	end
end
local function UpdateGrowAlarmSound(p)
	if not (hq_huge.value) then return end
	--if not (p.mo and p.mo.valid) then return end

	if p.mo.health > 0 and p.huge > 0 and localplayer != p 
	and p.kartstuff[k_invincibilitytimer] == 0 //Prioritize Grow
		if (CV_FindVar("kartinvinsfx").value)
			sfxnum = sfx_hqa
		else
			sfxnum = sfx_hq
		end
	else
		sfxnum = 0
	end
	if (sfxnum != 0) and (not S_SoundPlaying(p.mo, sfxnum))
		S_StartSound(p.mo, sfxnum)
		S_StartSound(p.mo, sfxnum)
	end
	STOPTHIS(p, sfx_hqa)
	STOPTHIS(p, sfx_hq)
end

--Goddammit, Acro
local function HQ_BoostExtend(p)
	if not hq_dynamictimer.value then return end
	if p.kartstuff[k_floorboost] then
		p.mo.hqpadboost = true
	elseif not p.kartstuff[k_sneakertimer]
	and p.mo.hqpadboost then
		p.mo.hqpadboost = nil
	end

	if (p.kartstuff[k_sneakertimer] and not p.trickboost and not p.mo.hqpadboost)
	or p.mo.recharge then
		if p.huge > 0
			p.huge = $+2
		end
		
		if p.mo.sparkle
		and not p.hqsuper then
			p.mo.sparkle = $+2
		end
	end
end


-- Fuck everything about this.
local function HQ_Eggman(p)
	if not p.kartstuff[k_eggmanexplode] then return end

	if p.kartstuff[k_eggmanexplode] > 0 then
		if leveltime%5 == 1 or (pks[k_eggmanexplode] < 55 and leveltime%2 == 1) --more intense flashing as you run out of time
			p.mo.colorized = true
			p.mo.color = SKINCOLOR_CRIMSON
		else
			p.mo.colorized = false
			p.mo.color = p.skincolor	
		end
	end
end

local function HQ_Debug(p)
	if not hq_debug.value then return end
	
	if p.huge > 0 then
		p.huge = max($, 99*TICRATE)
	end
	
	if p.mo.sparkle
	and not p.hqsuper then
		p.mo.sparkle = max($, 99*TICRATE)
	end

	if not p.hqsuper then
		if p.kartstuff[k_itemroulette] then
			p.kartstuff[k_itemroulette] = (3*TICRATE) - 1
		end
	end
	
	

	--if p.huge > 0 then
		--print("Huge: "..buildTimeString(p.huge))
	--end

	--if p.mo.sparkle > 0
		--print("Sparkle: "..buildTimeString(p.mo.sparkle))
	--end
end

---HUGE QUEST---
addHook("MapLoad", function()
	for p in players.iterate
		p.hqinit = nil
		p.hqsuperfinish = false
	end
end)

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	for p in players.iterate
		if not p.hqinit then
			hq_init(p)
			p.hqinit = true
		end	
		
		UpdateGrowAlarmSound(p)
		
		if not (p.mo and p.mo.valid) then continue end
		if leveltime <= STARTTIME then continue end
		
		if hq_allsuper.value then
			if p.hqsuper then
				//print(p.mo.color)
				p.mo.sparkle = 99*TICRATE
			end
			if p.kartstuff[k_itemroulette] == 1 then
				K_StripItems(p)
			end
		end
		
		HQ_Debug(p)

		--HQ_PowerEnd(p)
		
		-- Assign default glow color and reset dynamic glow when changing characters
		if not p.mo.hqassignedcolor
		and p.mo.hqsupernumber == nil then
			p.mo.hqsupernumber = 0
			p.mo.hqassignedcolor = true
		end

		if HOSTMOD then
			if p.huge > 0 and p.huge <= 3*TICRATE
				local r = p.huge / TICRATE + 1
				local d = r*2 + 1
				if (CV_FindVar("powerflash").value) then
					if (leveltime % d < r) and (CV_FindVar("powerflash").value)
						if hq_offroad.value
							p.mo.color = SKINCOLOR_YELLOW
						else
							p.mo.color = SKINCOLOR_PERIWINKLE
						end
						p.mo.colorized = true
					else
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				end
				if not (p.huge % TICRATE) and (CV_FindVar("powersound").value) then
					S_StartSound(nil, sfx_s242, p)
				end
			end
		end

		if p.exiting
		and p.hqsuper
		and not p.hqsuperfinish then
			p.hqsuperfinish = 1
			//print("Hyper Combo Finish!")
		end
		
		-- Player stuff; should take priority over above conditionals
		K_JumpStore(p)
		HQ_BoostExtend(p)
		HQ_LeadBuffer(p)
		K_HugeQuest(p)
		K_HQBonk(p)
		K_Stardust(p)
		HQ_HandlingMod(p)
		
		HQ_PowerColor(p)
		
		if p.playerstate ~= PST_LIVE
			p.hqsuper = 0
			if p.mo.sparkle then
				p.mo.sparkle = 0
				p.kartstuff[k_invincibilitytimer] = 0
			end
		end
		
		if hq_supercolor.value == -1 then
			p.lastskin = $ or -1
			if p.mo.skin ~= p.lastskin then
				p.mo.hqsupernumber = nil
				p.mo.hqassignedcolor = false
			end

			p.lastskin = p.mo.skin
		end
		
		
		if p.kartstuff[k_squishedtimer]
		and hq_altsquish.value
		and not p.exiting then -- FUCK.
			if (CV_FindVar("kmp_respawnpoints") and CV_FindVar("kmp_respawnpoints").value) then
				p.mo.kmp_respawned = 2*TICRATE
				p.kmp_respawn = nil
			end
			P_KillMobj(p.mo)
			p.kartstuff[k_squishedtimer] = 0
		end
	end
end)


addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if (mo.target.target and mo.target.target.player)
	and not mo.hqsignset then
		//print("Sign linked to player.")
		//print("Did player finish in Super Form? "..mo.target.target.player.hqsuperfinish)
		if mo.target.target.player.hqsuperfinish
			mo.hqsupersign = true
			//print("Super Finish!")
		end
		mo.hqsignset = 1
		//print("Sign set.")
	end

	if mo.hqsupersign
	and not mo.hqsupergoalset then
		mo.hqsupercycle = 1
		-- Keep Sign color the same even if you change colors after the 
		-- sign spawns
		if hq_supercolor.value == -1 then
			mo.hqsuperglow = mo.target.target.player.mo.hqsupernumber
		else
			mo.hqsuperglow = hq_supercolor.value
		end
		mo.hqsupergoalset = 1 -- This keeps the goalpost the same in case you switch characters while a race is still underway.
	end

	if mo.hqsupergoalset then
		if leveltime%3 == 0 then
			if mo.hqsupercycle >= #HQ_animSuper[mo.hqsuperglow] then
				mo.hqsupercycle = 1
			else
				mo.hqsupercycle = $ + 1
			end
			mo.color = HQ_animSuper[mo.hqsuperglow][mo.hqsupercycle]
		end
	end
end, MT_OVERLAY)

---Hitfeed Support: Thank you Snu---
local function hqSquish(p, inflictor, source)
	if not (hq_huge.value) then return end
	if (hitfeed)
		if not (source and source.player) return end
		if not (p.mo and p.mo.valid) return end
		if (inflictor and inflictor.player) then
			if source.player.huge > 0
				local s_hq = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
				local v_hq = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
				if (s_hq[3] == v_hq[3]) then source = nil end	-- source == victim, remove source
				local icon_hq = "K_HMGROW"
				
				if source.player.hqsuper
					if not HF_animIcon["K_HQSUP"] then HF_animIcon["K_HQSUP"] = {2,2} end
					local icon_hq = "K_HQSUP"
				end

				HF_SendHitMessage(s_hq, v_hq, icon_hq)
			end
		end
	end

	if (source and source.player)
	and ((source.player.huge > 0 or source.player.hqsuper) or (source.scale > p.mo.scale))
	and hq_altsquish.value then
		if hq_dynamictimer.value then
			source.player.huge = $ + (TICRATE)
		end
		P_DamageMobj(p.mo, inflictor, source)
		return true
	end
	return
end
addHook("PlayerSquish", hqSquish)

---YEET (from Benji)---
addHook("PlayerSpin", function(p, inf, source)
	if not (inf and inf.valid) or not (hq_huge.value) then return end
	
	if (inf.scale == (mapobjectscale*2) 
	and ((inf.type == MT_ORBINAUT) 							
	or (inf.type == MT_ORBINAUT_SHIELD) 
	or (inf.type == MT_JAWZ) 
	or (inf.type == MT_JAWZ_DUD) 
	or (inf.type == MT_JAWZ_SHIELD)
	or (inf.type == MT_BANANA) 
	or (inf.type == MT_BANANA_SHIELD) 
	or (inf.type == MT_BALLHOG)))
	or (inf and inf.player and inf.player.hqsuper)
		--print("ow")
		p.hqspeen = true
	end
	
	-- Grow/Sparkle extension
	if ((inf.type == MT_ORBINAUT) 							
	or (inf.type == MT_ORBINAUT_SHIELD) 
	or (inf.type == MT_JAWZ) 
	or (inf.type == MT_JAWZ_DUD) 
	or (inf.type == MT_JAWZ_SHIELD)
	or (inf.type == MT_BANANA) 
	or (inf.type == MT_BANANA_SHIELD) 
	or (inf.type == MT_BALLHOG))
		if source and source.player
			if source.player.huge > 0
			or source.player.mo.sparkle
			and hq_dynamictimer.value
				if source.player.huge
					source.player.huge = $ + (TICRATE/2)
				end
					
				if source.player.mo.sparkle
					source.player.mo.sparkle = $ + (TICRATE/2)
				end
				S_StartSound(source, sfx_token, source.player)
			end
		end
	elseif (inf.type == MT_PLAYER)
		if source and source.player
			if (source.player.huge > 0
			or source.player.mo.sparkle)
			and hq_dynamictimer.value
				if source.player.huge
					source.player.huge = $ + (TICRATE)
				end
					
				if source.player.mo.sparkle
					source.player.mo.sparkle = $ + (TICRATE)
				end
				S_StartSound(source, sfx_token, source.player)
			end

			if (source.player.huge and hq_altsquish.value)
			or source.player.hqsuper then
				p.hqtackle = true
			end

			if (hitfeed)
				local s_hq = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
				local v_hq = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
				if (s_hq[3] == v_hq[3]) then source = nil end	-- source == victim, remove source
				local icon_hq
				if source.player.hqsuper
					if not HF_animIcon["K_HQSUP"] then HF_animIcon["K_HQSUP"] = {2,2} end
					icon_hq = "K_HQSUP"
				end

				HF_SendHitMessage(s_hq, v_hq, icon_hq)
			end
		end
	end
end)

addHook("PlayerExplode", function(p, inf, source)
	if not (inf and inf.valid) then return end
	
	if hq_huge.value
		if inf.scale == (mapobjectscale*2) and ((inf.type == MT_SSMINE) or (inf.type == MT_SSMINE_SHIELD) or (inf.type == MT_MINEEXPLOSION))
			//print("ow")
			p.hqboom = true
		end
	end
end)

hud.add(function(v, p, c)
	localplayer = p
end)