local hq_dyk = {
	{msg = "Grow+ allows for item usage while active. Go wreak havoc!", cvartrue = "hq_huge"},
	{msg = "Item odds during Grow+ heavily favor attack items, with a chance to roll 4x Orbis or 10x Bananas!", cvartrue = "hq_huge"},
	{msg = "Most attacks items are now twice as large when used during Grow+. Some even split on impact!", cvartrue = "hq_huge"},
	{msg = "Big Orbis fired during Grow+ will split into two smaller Orbis upon impact with an item, player, or wall. M-M-Multiball!", cvartrue = "hq_huge"},
	{msg = "Big Bananas dropped/shot during Grow+ will split into three smaller bananas upon impact with an item or a player. Praise be to Banan.", cvartrue = "hq_huge"},
	{msg = "Grow+ will offer offroad immunity, allowing you to gain ground faster at the cost of a smaller speed bonus and duration compared to Vanilla Grow.", cvartrue = "hq_huge"},
	{msg = "Your Grow+ timer will extend if using another Grow while active.", cvartrue = "hq_huge"},
	{msg = "Your Invincibility timer will extend if using another Invincibility while active.", cvartrue = "hq_sparkle"},
	{msg = "If you have an active mini turbo while airborne, it will be preserved until you land.", cvartrue = "hq_jumpstore"},
	{msg = "If you have an active mini turbo during sneaker effects, it will be preserved until the effects wear off, and your fast lines will be green!", cvartrue = "hq_jumpstore"},
	{msg = "Be careful when near a Grow+ player - getting hit by one of their items results in extended spinout!", cvartrue = "hq_huge"},
	{msg = "Activating both Grow+ and Invincibility will trigger Super Mode!",  cvartrue = "hq_superform"},
	{msg = "Flatten people with Grow+ to increase your timer by 2 seconds!",  cvartrue = "hq_huge"},
	{msg = "Ram people with Invincibility to increase your timer by 2 seconds!",  cvartrue = "hq_sparkle"},
	
}

local hqload = false
local function HQ_Hostmod()
	if hqload then return end
	if not hqload
	and leveltime > 1
	and HOSTMOD then	--check for hostmod
		for i = 1, #hq_dyk
			HM_Scoreboard_AddTip(hq_dyk[i])
		end

		HM_Scoreboard_AddMod({disp = "Midair MT Storage", var = "hq_jumpstore"})
		HM_Scoreboard_AddMod({disp = "Grow+ Timer Stack", var = "hq_huge"})
		HM_Scoreboard_AddMod({disp = "Grow+ Item Split", var = "hq_huge"})
		HM_Scoreboard_AddMod({disp = "Grow+ Offroad", var = "hq_offroad"})
		HM_Scoreboard_AddMod({disp = "Grow+ Eggbomb Karma", var = "hq_huge"})
		HM_Scoreboard_AddMod({disp = "Grow+ Fling", var = "hq_altsquish"})
		HM_Scoreboard_AddMod({disp = "Inv+ Timer Stack", var = "hq_sparkle"})
		HM_Scoreboard_AddMod({disp = "Super Form", var = "hq_superform"})
		HM_Scoreboard_AddMod({disp = "Deadly Crushers", var = "hq_altsquish"})
		HM_Scoreboard_AddMod({disp = "Dynamic Power Timer", var = "hq_dynamictimer"})
		hqload = true
	end
end

addHook("MapLoad", HQ_Hostmod)
addHook("NetVars", HQ_Hostmod)